/*
 * Copyright (c) 2009 Kathryn Huxtable and Kenneth Orr.
 *
 * This file is part of the SeaGlass Pluggable Look and Feel.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Id: SeaGlassDropShadowEffect.java 1103 2010-02-06 20:07:09Z kathryn@kathrynhuxtable.org $
 */
package com.seaglasslookandfeel.effect;

import javax.swing.UIManager;

/**
 * Customized Nimbus's drop shadow effect for SeaGlass.
 *
 * @author Kathryn Huxtable
 */
public class SeaGlassDropShadowEffect extends DropShadowEffect {

    /**
     * Creates a new SeaGlassDropShadowEffect object.
     */
    public SeaGlassDropShadowEffect() {
        color    = UIManager.getColor("seaGlassDropShadow");
        angle    = 90;
        distance = 1;
        size     = 2;
        opacity  = 0.15f;
    }
}
